<?php
/*************************************************************************/
// Calendarizm ver0.6
// copyright@tenderfeel(http://tenderfeel.xsrv.jp/)
/*************************************************************************/

//初期設定

//戻り先
define('BACKURL','index.php'); 

//表示先からのディレクトリ名
define('DIRPASS','');

//ログファイル
define('FILENAME','log.dat');

//パスワード
define('LOGIN_PASS','pass');

//ログ保存件数
define('LOGMAX','50');

//リンクの別窓表示（する場合はtrue）
//trueでリンクにtarget="_blank"をつけますが、XHTMLでInvalidになります
define('TARGET',true);

/*************************************************************************
 使用方法

１．表示するページにincudeを入れます
<?php include_once('calendarizm.php'); ?>


２．カレンダーを表示したい場所に次の関数を書きます。
<?php get_calendar($style,$mode,$id,$width,$border,$cellpadding,$cellspacing); ?>

$style(string:list/table)
　テーブルスタイル。listで1日1行、tableで1週１行のテーブルになります。デフォルトはtable
$mode(boolean:true/false)
　trueにするとログファイルのデータを出力せずカレンダーだけの表示になります。デフォルトはfalse
$id(string)
　カレンダーのテーブルにつけるID。命名規則はCSSの仕様に基づく。デフォルトはcalendar
$width(integer)
　カレンダーテーブルの横幅。デフォルトはありません
$border(integer)
　カレンダーテーブルのボーダー。デフォルトは1。
$cellpadding(integer)
　カレンダーテーブルのセルとセルの間隔。デフォルトは0
$cellspacing(integer)
　カレンダーテーブルのセル内内側の余白。デフォルトは0


３．管理画面へのログインフォーム
<?php loginform($pass,$id);?>

$pass(string)
　関数を使用しているファイルからのadmin.phpへのパス。デフォルトはadmin.php（同じ階層）
$id(string)
　フォームタグにつけるID。デフォルトはありません

************************************************************************/

/* ----- Calendarizm Start!!-----*/
define('SCRIPT','Calendarizm');
define('VERSION','ver0.6');

class Calendar{

	var $date_timestamp;
	var $month;
	var $year;
	var $first_date;
	var $last_date;
	var $first_day;
	var $last_day;
	var $week;
	var $jpweek;
	var $today;
	
	function Calendar(){
	
		if (isset($_GET["location"]) && $_GET["location"] != "" && $_GET["location"]!=0) {
			$this->date_timestamp = $_GET["location"];
		} else {
			$this->date_timestamp = time();
		}
		$this->today = date("Ymd");
		
		$this->month = date("m", $this->date_timestamp);
		$this->year = date("Y", $this->date_timestamp);
		
		$this->first_date = mktime(0, 0, 0, $this->month, 1, $this->year);
		$this->last_date = mktime(0, 0, 0, $this->month + 1, 0, $this->year); 
		
		$this->first_day = date("j", $this->first_date);
		$this->last_day = date("j", $this->last_date);
		$this->jpweek = array("日","月","火","水","木","金","土");
		
		for($day = $this->first_day; $day <= $this->last_day; $day++) {
			$this->day_timestamp = mktime(0, 0, 0, $this->month, $day, $this->year);
			$this->week[$day] = date("w", $this->day_timestamp);
		}
	}
	function filechecks($name){
		if(file_exists($name)){
			$file = filesize($name);
			if($file==0){
				return 1;
			}elseif($file > 0){
				return $this->loadfile($name);
			}
		}else{
			return false;
		}
	}
	function loadfile($name){
		$file = @file($name);
		return $file;
	}
	function wikidecode($text){
	
		if(TARGET==true){$target=" target=\"_blank\"";}
	
		$wiki_characters= array('/\|{2}(.+?)\|{2}/i','/\'{2}(.+?)\'{2}/i','/\[{2}(.+?)&gt;(.*?)\]{2}/i','/color\(([\w]+?)\)\173(.+?)\175/i','/color\((#[\d]{6})\)\173(.+?)\175/i','/\[br\]?/');
		$wiki_replace = array('<strong>$1</strong>','<em>$1</em>',"<a href=\"$2\"$target>$1</a>",'<span style="color:$1;">$2</span>','<span style="color:$1;">$2</span>','<br />');

		$output= preg_replace($wiki_characters,$wiki_replace,$text);

		return $output;
	}
	function add_class($w,$c){
		$wclass=null;
		if($w==0){
			$wclass = 'sun';
		}elseif($w==6){
			$wclass = 'sat';
		}
		
		if($c==1){
			$current = "today";
		}else{
			$current = "";
		}
		
		if(isset($wclass)&&$c==1){
			$tag =" class=\"$wclass $current\"";
		}elseif(isset($wclass)){
			$tag =" class=\"$wclass\"";
		}elseif($c==1){
			$tag =" class=\"$current\"";
		}else{
			$tag ="";
		}	
		return $tag;
	}
	function scriptname(){
		print "<address class=\"wtn\"><a href=\"http://tenderfeel.xsrv.jp/\" title=\"WebTecNote*".SCRIPT."&nbsp;".VERSION."\">&copy;WTN*".SCRIPT."</a></address>\n";
	}
	function calendar_body_one($schedule_list){
		print "<caption>\n";
		print "<span class=\"year\">".date("Y", $this->date_timestamp)."年</span><span class=\"month\">".date("n", $this->date_timestamp)."月</span>";
		print "</caption>\n";
		print "<tbody>\n";
		$exist_data = false;
			
		if(isset($schedule_list)){
			foreach ($schedule_list as $lineno => $line) {
			list($timestamp,$schedule_date,$body) = explode(",", $line);
				if ($schedule_date == $this->year.$this->month.sprintf("%02d", date("j", $this->date_timestamp))) {
					 $exist_data = true;
					break;
				}
			}
		}
		
		$tag = $this->add_class($this->week[date("j", $this->date_timestamp)],0);
		
		$w = date("w",mktime(0, 0, 0, $this->month,date("j", $this->date_timestamp),$this->year));
		
		$body = $this->wikidecode($body);
		print "<tr><th scope=\"row\"".$tag."><span class=\"day\">".date("j", $this->date_timestamp)."日</span>"."<span class=\"week\">（".$this->jpweek[$w]."）"."</span></th></tr>\n";
		print "<tr>\n";
			if ($exist_data== true) {
				print "<td".$tag.">".$body."</td></tr>\n";
			}else{
				print "<td".$tag.">&nbsp;</td></tr>\n";
			}
	}
	function calendar_body_list($schedule_list){
		print "<caption>\n";
		print '<a href="'.$_SERVER['PHP_SELF'].'?location='.strtotime("-1 month", $this->first_date).'" class="back">&laquo;</a>';
		print date("Y", $this->date_timestamp)."年".date("n", $this->date_timestamp)."月";
		print '<a href="'.$_SERVER['PHP_SELF'].'?location='.strtotime("+1 month", $this->first_date).'" class="next">&raquo;</a>';
		print "</caption>\n";
		print "<tbody>\n";
		
		for ($day = $this->first_day; $day <= $this->last_day; $day++) {
		
		$exist_data = false;
			
		if(isset($schedule_list)){
			foreach ($schedule_list as $lineno => $line) {
			list($timestamp,$schedule_date,$body) = explode(",", $line);
				if ($schedule_date == $this->year.$this->month.sprintf("%02d", $day)) {
					 $exist_data = true;
					break;
				}
			}
		}
			$current_day =  $this->year.$this->month.sprintf("%02d", $day);
			$current = 0;
			
			if($this->today==$current_day){
				$current = 1;
			}
			
			$tag = $this->add_class($this->week[$day],$current);
			$w = date("w",mktime(0, 0, 0, $this->month,$day,$this->year));
			
			$body = $this->wikidecode($body);
			
			print "<tr><th scope=\"row\"".$tag.">".$day."（".$this->jpweek[$w]."）"."</th>";
			if ($exist_data== true) {
				print "<td".$tag.">".$body."</td></tr>\n";
			}else{
				print "<td".$tag.">&nbsp;</td></tr>\n";
			}
		}
	}
	function calendar_body_table($schedule_list){
		print "<caption>";
		print '<a href="'.$_SERVER['PHP_SELF'].'?location='.strtotime("-1 month", $this->first_date).'" class="back">&laquo;</a>';
		print date("Y", $this->date_timestamp)."年".date("n", $this->date_timestamp)."月";
		print '<a href="'.$_SERVER['PHP_SELF'].'?location='.strtotime("+1 month", $this->first_date).'" class="next">&raquo;</a>';
		print "</caption>\n";
		print "<thead>\n";
		print "<tr>\n";
		print "<th scope=\"col\">".$this->jpweek[0]."</th>\n";
		print "<th scope=\"col\">".$this->jpweek[1]."</th>\n"; 
		print "<th scope=\"col\">".$this->jpweek[2]."</th>\n";
		print "<th scope=\"col\">".$this->jpweek[3]."</th>\n";
		print "<th scope=\"col\">".$this->jpweek[4]."</th>\n";
		print "<th scope=\"col\">".$this->jpweek[5]."</th>\n";
		print "<th scope=\"col\">".$this->jpweek[6]."</th>\n";
	 	print "</tr>\n</thead>\n";
		print "<tbody>\n";
		if($this->week[$this->first_day] != 0){
			print "<tr>\n";
		}
		for ($i = 0; $i < $this->week[$this->first_day]; $i++) {
    		print ("<td>&nbsp;</td>\n"); 
    	}
		for ($day = $this->first_day; $day <= $this->last_day; $day++) {
			
			$exist_data = false;
			
			if(isset($schedule_list)){
			
				foreach ($schedule_list as $lineno => $line) {
			
				list($timestamp,$schedule_date,$body) = explode(",", $line);
			
					if ($schedule_date == $this->year.$this->month.sprintf("%02d", $day)) {
						 $exist_data = true;
						break;
					}
				}
			}
			if($day==$this->first_day&&$this->week[$day] == 0){
				print "<tr>\n";
 	    	}elseif($this->week[$day] == 0) {
				print "</tr>\n<tr>\n";
     		}
			$current_day =  $this->year.$this->month.sprintf("%02d", $day);
			$current = 0;
			
			if($this->today==$current_day){
				$current = 1;
			}
			
			$tag = $this->add_class($this->week[$day],$current);
			$body = $this->wikidecode($body);
			
			if ($exist_data== true) { //スケジュール表示
				print "<td$tag><tt>$day</tt><br />$body</td>\n";
			}else{
     			print ("<td$tag><tt>$day</tt></td>\n");
			}
		} 
     	//空白 
		for ($i = $this->week[$this->last_day]; $i < 6; $i++) { 
    		print ("<td>&nbsp;</td>\n"); 
    	}
		
		print "</tr>\n";
	}
	
}
/* Admin Calendar Class */
class AdminCalendar extends Calendar {
	function delete_button(){
		print '<p class="delete_button"><button type="submit">チェックしたものを削除</button></p>'."\n";
	}
	function view(){
		if(isset($_GET["location"])){
			$loc=$_GET["location"];
		}else{
			$loc="0";
		}
		print "<form action=\"\" method=\"post\">\n";
		print "<input type=\"hidden\" name=\"action\" value=\"delete\" />";
		$this->delete_button();
		print "<table border=\"1\" id=\"schedule_list\">";
		
		print "<caption>\n";
		print '<a href="'.$_SERVER['PHP_SELF'].'?location='.strtotime("-1 month", $this->first_date).'" class="back">&laquo; Back</a>';
		print date("Y", $this->date_timestamp)."年".date("n", $this->date_timestamp)."月";
		print '<a href="'.$_SERVER['PHP_SELF'].'?location='.strtotime("+1 month", $this->first_date).'" class="next">Next &raquo;</a>';
		print '</caption>';
		print "<thead>\n";
		print "<tr>\n";
		print "<th scope=\"col\"></th>";
		print "<th scope=\"col\">予定内容</th>"; 
		print "<th scope=\"col\" class=\"del\">削除</th>";
	 	print "</tr></thead>\n";
		print "<tbody>";
	
		$schedule_list = Calendar::filechecks(FILENAME);
		
		for ($day = $this->first_day; $day <= $this->last_day; $day++) {
		
			$exist_data = false;
			
		if(isset($schedule_list)){
			foreach ($schedule_list as $lineno => $line) {
		
			list($timestamp,$schedule_date,$body) = explode(",", $line);
			
			$current_date = $this->year.$this->month.sprintf("%02d", $day);
				if ($schedule_date == $current_date) {
					 $exist_data = true;
					break;
				}
			}
		}
			$current_day =  $this->year.$this->month.sprintf("%02d", $day);
			$current = 0;
			
			if($this->today==$current_day){
				$current = 1;
			}
			$tag = Calendar::add_class($this->week[$day],$current);
			$w = date("w", mktime(0, 0, 0, $this->month,$day,$this->year));
			$body = $this->wikidecode($body);
			
			print "<tr>\n";
			
			if ($exist_data== true) {
				print "<th scope=\"row\"".$tag."><a href=\"".$_SERVER['PHP_SELF']."?mode=edit&amp;date=$schedule_date&amp;loc=$loc\">".$day."（".$this->jpweek[$w].")</a>"."</th>";
				print "<td$tag>$body</td><td class=\"del\"><input name=\"delid[]\" type=\"checkbox\" value=\"$current_date\" /></td>\n";
			}else{
     			print "<th scope=\"row\"".$tag."><a href=\"".$_SERVER['PHP_SELF']."?mode=new&amp;date=$this->year$this->month".sprintf("%02d", $day)."&amp;loc=$loc\">".$day."（".$this->jpweek[$w].")</a></th>\n";
				print "<td>&nbsp;</td><td>&nbsp;</td>\n";
			}
			print "</tr>\n";
		}
		print "</tbody>\n</table>\n";
		$this->delete_button();
		print "</form>\n";
	}
}

/* Calenderizm main function */
function get_calendar($style="table",$mode=false,$width=null,$border=1,$cellpadding=0,$cellspacing=0,$id="calendar"){
	$calendar = new Calendar();
	
	if($mode==true) $schedule_list = null;
	else $schedule_list = $calendar->filechecks(DIRPASS.FILENAME);
	
	if(isset($width)) $width=' width="'.$width.'" ';
	else $width=' ';
	
	
	print "\n".'<table'.$width.'border="'.$border.'" cellspacing="'.$cellspacing.'" cellpadding="'.$cellpadding.'" id="'.$id.'">'."\n";
	
	if($schedule_list==false&&$mode==false){
		print "<tr><td class=\"error-message\"><strong>ERROR</strong><br />ログファイルが開けません$schedule_list</td></tr>\n";
	}elseif($schedule_list==1&&$mode==false){
		if($style=="list"){
			$calendar->calendar_body_list(null);
		}elseif($style=="table"){
			$calendar->calendar_body_table(null);
		}elseif($style=="oneday"){
			$calendar->calendar_body_one(null);
		}
	}else{
		if($style=="list"){
			$calendar->calendar_body_list($schedule_list);
		}elseif($style=="table"){
			$calendar->calendar_body_table($schedule_list);
		}elseif($style=="oneday"){
			$calendar->calendar_body_one($schedule_list);
		}
	}
	print "</tbody>\n</table>\n";
	$calendar->scriptname();
}
/* loginform for admin */
function loginform($pass="admin.php",$id=null){
	if(isset($id)){
		$id = ' id="'.$id.'"';
	}
print "\n<form action=\"$pass\" method=\"post\"".$id.">\n";
print "<p><input type =\"text\" name=\"loginPass\" id=\"loginPass\" />\n";
print "<input type=\"hidden\" name=\"action\" value=\"LOGIN\" />";
print "<button type=\"submit\">admin</button></p>\n";
print "</form>\n";
}
?>